<?php
 
if($action=='edit'){
    if(!empty($_POST))
    {    
    $errors=[];
    $query="SELECT id FROM users WHERE username=:username AND id!=:id and active=1";
    $username=query($query,['username'=>$_POST['username'],'id'=>$_POST['id']]);
    if(empty($_POST['username']))
    {
      $errors['username']="Username is required";
    }
    elseif($username)
    {
      $errors['username']="Username already exists";
    }
    elseif(preg_match('/[^a-zA-Z0-9]/',$_POST['username']))
    {
      $errors['username']="Username can only contain alphabets and numbers";
    }
    elseif(strlen($_POST['username'])<5)
    {
      $errors['username']="Username must be atleast 5 characters long";
    }

    $query="SELECT id FROM users WHERE email=:email AND id!=:id and active=1";
    $email=query($query,['email'=>$_POST['email'],'id'=>$_POST['id']]);

    if(empty($_POST['email']))
    {
      $errors['email']="Email is required";
    }
    elseif($email)
    {
      $errors['email']="Email already exists";
    }

    if(empty($_POST['password']))
    {
      
    }
    elseif(strlen($_POST['password'])<5)
    {
      $errors['password']="Password must be atleast 5 characters long";
    }
  

    //validate Image

    $allowed = ['image/jpeg','image/jpg','image/png','image/gif','image/webp'];


    $allowed = ['image/jpeg', 'image/jpg', 'image/png', 'image/gif', 'image/webp'];
    
    if ($_SERVER['REQUEST_METHOD'] == 'POST' && !empty($_FILES['image']['name'])) {
        // Check if a cropped image is sent via POST
        if (!empty($_POST['cropped_image'])) {
            $croppedImageData = $_POST['cropped_image'];
            // Remove base64 prefix
            $croppedImageData = str_replace("data:image/jpeg;base64,", "", $croppedImageData);
            $croppedImageData = base64_decode($croppedImageData);
    
            // Set upload directory
            $uploadDir = '/home/Iamrajesh/htdocs/blogs/public/uploads/';
            $fileName = time() . '.jpg'; // Save as a JPEG file
            $destination = $uploadDir . $fileName;
            $savePath = '/uploads/' . $fileName;
    
            // Save the cropped image
            if (file_put_contents($destination, $croppedImageData)) {
               // echo "Image uploaded successfully Cropper : " . $savePath;
                resize_image($destination);
            } else {
                $errors['image'] = 'Error saving cropped image.';
            }
        } 
        // Handle file uploads (if not using Cropper.js)
        elseif (!empty($_FILES['image']['name'])) {
            $fileName = basename($_FILES['image']['name']);
            $destination = $uploadDir . time() . $fileName;
            $savePath = '/uploads/' . time() . $fileName;
    
            // Validate file size
            if ($_FILES['image']['size'] > 2000000) {
                $errors['image'] = 'File size must be less than 2MB';
            }
            // Validate file type
            elseif (!in_array($_FILES['image']['type'], $allowed)) {
                $errors['image'] = 'File type is not allowed';
            }
            // Save & resize the image
            else {
                move_uploaded_file($_FILES['image']['tmp_name'], $destination);
                resize_image($destination, 500, 500); // Resize to 500x500
                echo "Image uploaded successfully Normal: " . $savePath;
            }
        } else {
            $errors['image'] = 'No image uploaded.';
        }
    }
  else{
    // echo "emprt image";
    $edit_id=$url[3] ?? '';
    $query="SELECT * FROM users where id=:id and active=1";
    $user=query_row($query,['id'=>$edit_id]);
    $savePath=$user['image'];
  }
  
  
    if(empty($errors))
    {
      $data=[];
      $data['email']=$_POST['email'];
      $data['username']=$_POST['username'];
      $data['id']=$_POST['id'];     
      $data['image']=$savePath;
      if(empty($_POST['password']))
      {
        //  echo "empty";
        $data['bio']=$_POST['bio'];
        $query="UPDATE users SET username=:username,email=:email,bio=:bio,image=:image WHERE id=:id";
      }
      else
      {
        // echo "not empty";
        $data['bio']=$_POST['bio'];
        $data['role']=$_POST['role'];
        // $data['password'] = $_POST['password'];
         $data['password']=password_hash($_POST['password'],PASSWORD_DEFAULT);
        $query="UPDATE users SET username=:username,email=:email,password=:password,bio=:bio,image=:image,role=:role WHERE id=:id";
    }

      query($query,$data); 
    
      redirect(ROOT.'/profile/'.$_SESSION['user_id']);
    
     }
  }
}  

?>