<?php
 
  // add new
if($action == 'add'){
    if(!empty($_POST))
    { 
    $errors=[];
    $query="SELECT id FROM categories WHERE category=:category and disabled=0 limit 1";
    $category=query($query,['category'=>$_POST['category']]);
    if(empty($_POST['category']))
    {
      $errors['category']="category is required";
    }
    elseif($category)
    {
      $errors['category']="category already exists";
    }
    elseif(strlen($_POST['category'])<3)
    {
      $errors['category']="category must be atleast 3 characters long";
    }

    $slug = str_to_url($_POST['category']);

    $query = "SELECT id FROM categories WHERE slug=:slug AND disabled=0 LIMIT 1";
    $existing_slug = query($query, ['slug' => $slug]);
    
    // Ensure $slug is a string
    if (!empty($existing_slug)) {
        $slug .= rand(1000, 9999);
    }
    
    if (empty($errors)) {
        $data = [];
        $data['category'] = $_POST['category'];
        $data['slug'] = $slug;
        $data['disabled'] = $_POST['disabled'];
    
        $query = "INSERT INTO categories (category, slug, disabled) VALUES (:category, :slug, :disabled)";
        query($query, $data);
        redirect(ROOT . '/admin/categories');
    }
    
  }
}

elseif($action=='edit'){
    if(!empty($_POST))
    {
    
    $errors=[];
    $query="SELECT id FROM categories WHERE category=:category AND id!=:id and active=1";
    $category=query($query,['category'=>$_POST['category'],'id'=>$_POST['id']]);
    if(empty($_POST['category']))
    {
      $errors['category']="category is required";
    }
    elseif($category)
    {
      $errors['category']="category already exists";
    }
    elseif(strlen($_POST['category'])<3)
    {
      $errors['category']="category must be atleast 3 characters long";
    }

    $slug = str_to_url($_POST['category']);

    $query = "SELECT id FROM categories WHERE slug=:slug AND disabled=0 LIMIT 1";
    $existing_slug = query($query, ['slug' => $slug]);
    
    // Ensure $slug is a string
    if (!empty($existing_slug)) {
        $slug .= rand(1000, 9999);
    }
   
  
    if(empty($errors))
    {
         $data=[];
         $data['category']=$_POST['category'];
         $data['slug']=$slug;
         $data['disabled']=$_POST['disabled'];
         $data['id']=$_POST['id'];
     
         $query="UPDATE categories SET category=:category,slug=:slug,disabled=:disabled WHERE id=:id";

      query($query,$data); 
    
       redirect(ROOT.'/admin/categories');
    
     }
  }
}  

?>