<?php
 
  // add new
if($action == 'add'){
    if(!empty($_POST))
    { 
    $errors=[];

    if(empty($_POST['title']))
    {
      $errors['title']="title is required";
    }
    elseif(strlen($_POST['title'])<3)
    {
      $errors['title']="title must be atleast 3 characters long";
    }

    if(empty($_POST['category_id']))
    {
      $errors['category_id']="category is required";
    }

    if(empty($_POST['content']))
    {
      $errors['content']="content is required";
    }

    //validate Image

    $allowed = ['image/jpeg', 'image/jpg', 'image/png', 'image/gif', 'image/webp'];
    
    if ($_SERVER['REQUEST_METHOD'] == 'POST') {
        // Check if a cropped image is sent via POST
        if (!empty($_POST['cropped_image'])) {
            $croppedImageData = $_POST['cropped_image'];
            // Remove base64 prefix
            $croppedImageData = str_replace("data:image/jpeg;base64,", "", $croppedImageData);
            $croppedImageData = base64_decode($croppedImageData);
    
            // Set upload directory
            $uploadDir = '/home/Iamrajesh/htdocs/blogs/public/uploads/';
            $fileName = time() . '.jpg'; // Save as a JPEG file
            $destination = $uploadDir . $fileName;
            $savePath = '/uploads/' . $fileName;
    
            // Save the cropped image
            if (file_put_contents($destination, $croppedImageData)) {
               // echo "Image uploaded successfully Cropper : " . $savePath;
                resize_image($destination);
            } else {
                $errors['image'] = 'Error saving cropped image.';
            }
        } 
        // Handle file uploads (if not using Cropper.js)
        elseif (!empty($_FILES['image']['name'])) {
            $fileName = basename($_FILES['image']['name']);
            $destination = $uploadDir . time() . $fileName;
            $savePath = '/uploads/' . time() . $fileName;
    
            // Validate file size
            if ($_FILES['image']['size'] > 2000000) {
                $errors['image'] = 'File size must be less than 2MB';
            }
            // Validate file type
            elseif (!in_array($_FILES['image']['type'], $allowed)) {
                $errors['image'] = 'File type is not allowed';
            }
            // Save & resize the image
            else {
                move_uploaded_file($_FILES['image']['tmp_name'], $destination);
                resize_image($destination, 500, 500); // Resize to 500x500
                echo "Image uploaded successfully Normal: " . $savePath;
            }
        } else {
            $errors['image'] = 'No image uploaded.';
        }
    }
    
   $slug = str_to_url($_POST['title']);

    $query = "SELECT id FROM posts WHERE slug=:slug AND active=1 LIMIT 1";
    $existing_slug = query($query, ['slug' => $slug]);
    
    // Ensure $slug is a string
    if (!empty($existing_slug)) {
        $slug .= rand(1000, 9999);
    }

    if(empty($errors))
    {
      $data=[];
      $data['category_id']=$_POST['category_id'];
      $data['title']=$_POST['title'];
      $data['content']=$_POST['content'];
      $data['date']=date('Y-m-d H:i:s'); 
      $data['image']=$savePath;
      $data['user_id']=user('id');
      $data['slug']=$slug;

      $query="INSERT INTO posts(category_id,title,content,image,date,user_id,slug) VALUES(:category_id,:title,:content,:image,:date,:user_id,:slug)";
    query($query,$data); 
    redirect(ROOT);
    }
  }
}

elseif($action=='edit'){
    if(!empty($_POST))
    {
    
    $errors=[];
    if(strlen($_POST['title'])<3)
    {
      $errors['title']="title must be atleast 3 characters long";
    }

    if(empty($_POST['category_id']))
    {
      $errors['category_id']="category is required";
    }

    if(empty($_POST['content']))
    {
      $errors['content']="content is required";
    }


    //validate Image

    $allowed = ['image/jpeg', 'image/jpg', 'image/png', 'image/gif', 'image/webp'];
    
    if ($_SERVER['REQUEST_METHOD'] == 'POST' && !empty($_FILES['image']['name'])) {
        // Check if a cropped image is sent via POST
        if (!empty($_POST['cropped_image'])) {
            $croppedImageData = $_POST['cropped_image'];
            // Remove base64 prefix
            $croppedImageData = str_replace("data:image/jpeg;base64,", "", $croppedImageData);
            $croppedImageData = base64_decode($croppedImageData);
    
            // Set upload directory
            $uploadDir = '/home/Iamrajesh/htdocs/blogs/public/uploads/';
            $fileName = time() . '.jpg'; // Save as a JPEG file
            $destination = $uploadDir . $fileName;
            $savePath = '/uploads/' . $fileName;
    
            // Save the cropped image
            if (file_put_contents($destination, $croppedImageData)) {
               // echo "Image uploaded successfully Cropper : " . $savePath;
                resize_image($destination);
            } else {
                $errors['image'] = 'Error saving cropped image.';
            }
        } 
        // Handle file uploads (if not using Cropper.js)
        elseif (!empty($_FILES['image']['name'])) {
            $fileName = basename($_FILES['image']['name']);
            $destination = $uploadDir . time() . $fileName;
            $savePath = '/uploads/' . time() . $fileName;
    
            // Validate file size
            if ($_FILES['image']['size'] > 2000000) {
                $errors['image'] = 'File size must be less than 2MB';
            }
            // Validate file type
            elseif (!in_array($_FILES['image']['type'], $allowed)) {
                $errors['image'] = 'File type is not allowed';
            }
            // Save & resize the image
            else {
                move_uploaded_file($_FILES['image']['tmp_name'], $destination);
                resize_image($destination, 500, 500); // Resize to 500x500
                echo "Image uploaded successfully Normal: " . $savePath;
            }
        } else {
            $errors['image'] = 'No image uploaded.';
        }
    }
  else{
    $edit_id=$url[3] ?? '';
    $query="SELECT * FROM posts where id=:id and active=1";
    $user=query_row($query,['id'=>$edit_id]);
    $savePath=$user['image'];
  }

  $slug = str_to_url($_POST['title']);

  $query = "SELECT id FROM posts WHERE slug=:slug AND active=1 LIMIT 1";
  $existing_slug = query($query, ['slug' => $slug]);
  
  // Ensure $slug is a string
  if (!empty($existing_slug)) {
      $slug .= rand(1000, 9999);
  }
  
    if(empty($errors))
    {
      $data=[];
      $data['category_id']=$_POST['category_id'];
      $data['title']=$_POST['title'];
      $data['id']=$_POST['id'];     
      $data['slug']=$slug;
      $data['image']=$savePath;
      $data['content']=$_POST['content'];

      $query="UPDATE posts SET category_id=:category_id,title=:title,slug=:slug,image=:image,content=:content WHERE id=:id";

      query($query,$data); 
    
       redirect(ROOT);
    
     }
  }
}  

?>